#include<bits/stdc++.h>
using namespace std;
int i,j,k,n,m,ans,dep[500005],f[500005][23],maxd;
int x,y,l,r,top;
vector<int> g[500005];
struct node{
	int x,fa,deep;
}q[500005];
int t[500005*4+5];
void bfs(){
	top=0;
	q[++top].deep=1,q[top].fa=0,q[top].x=1;
	while(top){
		int x=q[top].x,fa=q[top].fa,deep=q[top].deep;
		top--;
		maxd=max(maxd,deep);
		dep[x]=deep,f[x][0]=fa;
		for(int i=0;i<g[x].size();i++){
			int go=g[x][i];
			if(go!=fa) q[++top].x=go,q[top].fa=x,q[top].deep=deep+1;
		}
	}
	
	
}
int lca(int x,int y){
	if(dep[x]<dep[y]) swap(x,y);
	for(i=20;i>=0;i--){
		if(dep[f[x][i]]>=dep[y]) x=f[x][i];
	}
	if(x==y) return x;
	for(i=20;i>=0;i--){
		if(f[x][i]!=f[y][i]) x=f[x][i],y=f[y][i];
	}
	return f[x][0];
}
void build(int x,int l,int r){
	if(l==r){
		t[x]=dep[l];
		return ;
	}
	int mid=l+r>>1;
	build(x<<1,l,mid);
	build(x<<1|1,mid+1,r);
	t[x]=min(t[x<<1],t[x<<1|1]);
}
int ask(int x,int l,int r,int ql,int qr){
	if(l>=ql && r<=qr) return t[x];
	if(l>qr || r<ql) return 1e9;
	int mid=l+r>>1;
	return min(ask(x<<1,l,mid,ql,qr),ask(x<<1|1,mid+1,r,ql,qr));
}
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	ios::sync_with_stdio(0);
	cin>>n;
	for(i=1;i<n;i++){
		cin>>x>>y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	bfs();
	//for(i=1;i<=n;i++) cout<<i<<':'<<dep[i]<<'\n';
	for(j=1;j<=20;j++){
		for(i=1;i<=n;i++){
			f[i][j]=f[f[i][j-1]][j-1];
		}
	}
	build(1,1,n);
	cin>>m;
	while(m--){
		cin>>l>>r>>k;
		ans=0;
		if(maxd==n){
			cout<<ask(1,1,n,l,r)<<'\n';
			continue;
		}
		for(int o=l;o<=r;o++){
			int num=o;
			for(j=o;j<=r;j++){
				num=lca(num,j);
				//cout<<o<<" "<<j<<" "<<num<<" "<<dep[num]<<'\n';
				if(j-o+1>=k) ans=max(ans,dep[num]);
			}
		}
		cout<<ans<<'\n';
		
	}
	return 0;
} 

/*
6
5 6
6 1
6 2
2 3
2 4
3
2 5 2
1 4 1
1 6 3
*/
